<?php

class Shipping_Coordinadora_WC_Admin
{
    public function __construct()
    {
        add_action( 'init', array( $this, 'register_settings' ) );
        add_action( 'admin_menu', array($this, 'shipping_coordinadora_wc_cswc_menu'));
    }

    public function register_settings(): void
    {
        $schema = array(
            'type'       => 'object',
            'properties' => array(
                'enabled' => array(
                    'type' => 'string',
                    'enum' => array('no', 'yes')
                ),
                'environment' => array(
                    'type' => 'integer',
                    'enum' => array(0, 1)
                ),
                'api_key' => array(
                    'type' => 'string'
                ),
                'password_tracing' => array(
                    'type' => 'string'
                ),
                'nit' => array(
                    'type' => 'string'
                ),
                'code_account' => array(
                    'type' => 'integer',
                    'enum' => array(1, 2, 3, 6)
                ),
                'id_client' => array(
                    'type' => 'string'
                ),
                'user' => array(
                    'type' => 'string'
                ),
                'password_guides' => array(
                    'type' => 'string'
                ),
                'phone_sender' => array(
                    'type' => 'string'
                ),
                'guide_free_shipping' => array(
                    'type' => 'string',
                    'enum' => array('no', 'yes')
                ),
                'title' => array(
                    'type' => 'string'
                ),
                'debug' => array(
                    'type' => 'string',
                    'enum' => array('no', 'yes')
                ),
                'div' => array(
                    'type' => 'string'
                ),
                'weight_max' => array(
                    'type' => 'integer'
                ),
                'sender_name' => array(
                    'type' => 'string'
                ),
                'city_sender' => array(
                    'type' => 'string'
                ),
                'license_key' => array(
                    'type' => 'string'
                ),
                'sandbox_api_key' => array(
                    'type' => 'string'
                ),
                'sandbox_password_tracings' => array(
                    'type' => 'string'
                ),
                'sandbox_nit' => array(
                    'type' => 'string'
                ),
                'sandbox_id_client' => array(
                    'type' => 'string'
                ),
                'sandbox_user' => array(
                    'type' => 'string'
                ),
                'sandbox_password_guides' => array(
                    'type' => 'string'
                ),
                'sandbox_code_account' => array(
                    'type' => 'integer',
                    'enum' => array(1, 2, 3, 6)
                )
            )
        );

        $id = SHIPPING_COORDINADORA_WC_CSWC_ID;
        register_setting(
            'options',
            "woocommerce_{$id}_settings",
            array(
                'type'         => 'object',
                'default'      => array(
                    'enabled' => 'no',
                    'environment' => 0,
                    'api_key' => '',
                    'password_tracing' => '',
                    'nit' => '',
                    'id_client' => '',
                    'user' => '',
                    'password_guides' => '',
                    'code_account' => 1,
                    'phone_sender' => '',
                    'guide_free_shipping' => 'no',
                    'title' => 'Coordinadora',
                    'debug' => 'no',
                    'div' => '',
                    'weight_max' => 5,
                    'sender_name' => '',
                    'city_sender' => '',
                    'license_key' => '',
                    'sandbox_api_key' => '',
                    'sandbox_password_tracings' => '',
                    'sandbox_nit' => '',
                    'sandbox_id_client' => '',
                    'sandbox_user' => '',
                    'sandbox_password_guides' => '',
                    'sandbox_code_account' => 1
                ),
                'show_in_rest' => array(
                    'schema' => $schema
                ),
            )
        );
    }

    public function shipping_coordinadora_wc_cswc_menu(): void
    {
        add_submenu_page(
            'woocommerce',
            '',
            '',
            'manage_options',
            'wizard-coordinadora',
            array($this, 'wizard_coordinadora')
        );
    }

    public function wizard_coordinadora(): void
    {
        printf(
            '<div class="wrap" id="wizard-coordinadora">%s</div>',
            esc_html__( 'Cargando…')
        );
        ?>
        <?php
    }
}